<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseData ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseData extends AbstractStructArrayBase
{
    /**
     * The CruiseData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseData[]
     */
    public $CruiseData;
    /**
     * Constructor method for ArrayOfJP_CruiseData
     * @uses ArrayOfJP_CruiseData::setCruiseData()
     * @param \StructType\JP_CruiseData[] $cruiseData
     */
    public function __construct(array $cruiseData = array())
    {
        $this
            ->setCruiseData($cruiseData);
    }
    /**
     * Get CruiseData value
     * @return \StructType\JP_CruiseData[]|null
     */
    public function getCruiseData()
    {
        return $this->CruiseData;
    }
    /**
     * This method is responsible for validating the values passed to the setCruiseData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCruiseData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCruiseDataForArrayConstraintsFromSetCruiseData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CruiseDataCruiseDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseDataCruiseDataItem instanceof \StructType\JP_CruiseData) {
                $invalidValues[] = is_object($arrayOfJP_CruiseDataCruiseDataItem) ? get_class($arrayOfJP_CruiseDataCruiseDataItem) : sprintf('%s(%s)', gettype($arrayOfJP_CruiseDataCruiseDataItem), var_export($arrayOfJP_CruiseDataCruiseDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CruiseData property can only contain items of type \StructType\JP_CruiseData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CruiseData value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseData[] $cruiseData
     * @return \ArrayType\ArrayOfJP_CruiseData
     */
    public function setCruiseData(array $cruiseData = array())
    {
        // validation for constraint: array
        if ('' !== ($cruiseDataArrayErrorMessage = self::validateCruiseDataForArrayConstraintsFromSetCruiseData($cruiseData))) {
            throw new \InvalidArgumentException($cruiseDataArrayErrorMessage, __LINE__);
        }
        $this->CruiseData = $cruiseData;
        return $this;
    }
    /**
     * Add item to CruiseData value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseData $item
     * @return \ArrayType\ArrayOfJP_CruiseData
     */
    public function addToCruiseData(\StructType\JP_CruiseData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseData) {
            throw new \InvalidArgumentException(sprintf('The CruiseData property can only contain items of type \StructType\JP_CruiseData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CruiseData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CruiseData
     */
    public function getAttributeName()
    {
        return 'CruiseData';
    }
}
